"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.findSentinelSync = exports.findSentinel = exports.findPackagesSync = exports.findPackages = exports.WORKSPACE_ROOT_SENTINELS = exports.YARN_LOCK = exports.RUSH_JSON = exports.PNPM_WORKSPACE_YAML = exports.PACKAGE_LOCK_JSON = exports.LERNA_JSON = exports.BUN_LOCKB = exports.BUN_LOCK = void 0;
exports.getImplementation = getImplementation;
exports.getImplementationSync = getImplementationSync;
exports.readJSON = readJSON;
exports.readJSONSync = readJSONSync;
const fast_glob_1 = __importDefault(require("fast-glob"));
const find_up_1 = __importDefault(require("find-up"));
const fs_1 = require("fs");
const promises_1 = require("fs/promises");
const path = __importStar(require("path"));
const strip_json_comments_1 = __importDefault(require("strip-json-comments"));
exports.BUN_LOCK = "bun.lock";
exports.BUN_LOCKB = "bun.lockb";
exports.LERNA_JSON = "lerna.json";
exports.PACKAGE_LOCK_JSON = "package-lock.json";
exports.PNPM_WORKSPACE_YAML = "pnpm-workspace.yaml";
exports.RUSH_JSON = "rush.json";
exports.YARN_LOCK = "yarn.lock";
exports.WORKSPACE_ROOT_SENTINELS = [
    exports.LERNA_JSON,
    exports.RUSH_JSON,
    exports.YARN_LOCK,
    exports.PACKAGE_LOCK_JSON,
    exports.PNPM_WORKSPACE_YAML,
    exports.BUN_LOCK,
    exports.BUN_LOCKB,
];
const isTesting = Boolean(process.env.NODE_TEST_CONTEXT);
function dirnameAll(paths) {
    return paths.map((p) => path.dirname(p));
}
function makeFindSentinel(finder) {
    let result;
    return () => {
        if (isTesting || !result) {
            result = finder(exports.WORKSPACE_ROOT_SENTINELS);
        }
        return result;
    };
}
function makeFindPackages(glob, fallback, postprocess) {
    const ignore = ["**/Pods/**", "**/bower_components/**", "**/node_modules/**"];
    return (patterns, cwd) => {
        if (!Array.isArray(patterns)) {
            return fallback;
        }
        const pkgPatterns = patterns.map((p) => p + "/package.json");
        const result = glob(pkgPatterns, {
            cwd,
            ignore,
            absolute: true,
            onlyFiles: true,
        });
        return postprocess(result);
    };
}
exports.findPackages = makeFindPackages(fast_glob_1.default, Promise.resolve([]), (result) => result.then(dirnameAll));
exports.findPackagesSync = makeFindPackages(fast_glob_1.default.sync, [], dirnameAll);
exports.findSentinel = makeFindSentinel(find_up_1.default);
exports.findSentinelSync = makeFindSentinel(find_up_1.default.sync);
function getImplementation(sentinel) {
    switch (path.basename(sentinel)) {
        case exports.BUN_LOCK: // fallthrough — logic defining workspaces config is the same as for npm and yarn
        case exports.BUN_LOCKB: // fallthrough — logic defining workspaces config is the same as for npm and yarn
        case exports.PACKAGE_LOCK_JSON: // fallthrough — logic defining workspaces config is the same for npm and yarn
        case exports.YARN_LOCK:
            return Promise.resolve().then(() => __importStar(require("./yarn")));
        case exports.LERNA_JSON:
            return Promise.resolve().then(() => __importStar(require("./lerna")));
        case exports.PNPM_WORKSPACE_YAML:
            return Promise.resolve().then(() => __importStar(require("./pnpm")));
        case exports.RUSH_JSON:
            return Promise.resolve().then(() => __importStar(require("./rush")));
    }
    throw new Error(`This should not happen - did we forget to add a switch case for '${sentinel}'?`);
}
function getImplementationSync(sentinel) {
    switch (path.basename(sentinel)) {
        case exports.BUN_LOCK: // fallthrough — logic defining workspaces config is the same as for npm and yarn
        case exports.BUN_LOCKB: // fallthrough — logic defining workspaces config is the same as for npm and yarn
        case exports.PACKAGE_LOCK_JSON: // fallthrough — logic defining workspaces config is the same for npm and yarn
        case exports.YARN_LOCK:
            return require("./yarn");
        case exports.LERNA_JSON:
            return require("./lerna");
        case exports.PNPM_WORKSPACE_YAML:
            return require("./pnpm");
        case exports.RUSH_JSON:
            return require("./rush");
    }
    throw new Error(`This should not happen - did we forget to add a switch case for '${sentinel}'?`);
}
async function readJSON(path) {
    const json = await (0, promises_1.readFile)(path, { encoding: "utf-8" });
    return JSON.parse((0, strip_json_comments_1.default)(json));
}
function readJSONSync(path) {
    const json = (0, fs_1.readFileSync)(path, { encoding: "utf-8" });
    return JSON.parse((0, strip_json_comments_1.default)(json));
}
//# sourceMappingURL=common.js.map