"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.findWorkspacePackages = findWorkspacePackages;
exports.findWorkspacePackagesSync = findWorkspacePackagesSync;
exports.findWorkspaceRoot = findWorkspaceRoot;
exports.findWorkspaceRootSync = findWorkspaceRootSync;
exports.getWorkspacesInfo = getWorkspacesInfo;
exports.getWorkspacesInfoSync = getWorkspacesInfoSync;
const path = __importStar(require("path"));
const common_1 = require("./common");
const info_1 = require("./info");
/**
 * Returns a list of all packages declared under workspaces.
 */
async function findWorkspacePackages() {
    const sentinel = await (0, common_1.findSentinel)();
    if (!sentinel) {
        return [];
    }
    const { findWorkspacePackages } = await (0, common_1.getImplementation)(sentinel);
    return await findWorkspacePackages(sentinel);
}
/**
 * Returns a list of all packages declared under workspaces synchronously.
 */
function findWorkspacePackagesSync() {
    const sentinel = (0, common_1.findSentinelSync)();
    if (!sentinel) {
        return [];
    }
    const { findWorkspacePackagesSync } = (0, common_1.getImplementationSync)(sentinel);
    return findWorkspacePackagesSync(sentinel);
}
/**
 * Returns the root of the workspace; `undefined` if not a workspace.
 */
async function findWorkspaceRoot() {
    const sentinel = await (0, common_1.findSentinel)();
    return sentinel && path.dirname(sentinel);
}
/**
 * Returns the root of the workspace synchronously; `undefined` if not a
 * workspace.
 */
function findWorkspaceRootSync() {
    const sentinel = (0, common_1.findSentinelSync)();
    return sentinel && path.dirname(sentinel);
}
async function getWorkspacesInfo() {
    const sentinel = await (0, common_1.findSentinel)();
    if (!sentinel) {
        throw new Error("Could not find the root of the workspaces");
    }
    return new info_1.WorkspacesInfoImpl(sentinel);
}
function getWorkspacesInfoSync() {
    const sentinel = (0, common_1.findSentinelSync)();
    if (!sentinel) {
        throw new Error("Could not find the root of the workspaces");
    }
    return new info_1.WorkspacesInfoImpl(sentinel);
}
//# sourceMappingURL=index.js.map