"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkspacesInfoImpl = void 0;
const micromatch_1 = __importDefault(require("micromatch"));
const path = __importStar(require("node:path"));
const common_1 = require("./common");
class WorkspacesInfoImpl {
    constructor(sentinel) {
        this.sentinel = sentinel;
        this.root = path.dirname(sentinel);
        const { getPackageFilters, findWorkspacePackages, findWorkspacePackagesSync, } = (0, common_1.getImplementationSync)(sentinel);
        this.packageFilter = getPackageFilters(this.sentinel);
        this.findWorkspacePackages = findWorkspacePackages;
        this.findWorkspacePackagesSync = findWorkspacePackagesSync;
    }
    getRoot() {
        return this.root;
    }
    async findPackages() {
        if (!this.packages) {
            this.packages = await this.loadPackages();
        }
        return this.packages;
    }
    findPackagesSync() {
        if (!this.packages) {
            this.packages = this.loadPackagesSync();
        }
        return this.packages;
    }
    isWorkspace(packageRoot) {
        // if there is a package filter
        if (this.packageFilter) {
            // do glob matching to see if this fits the pattern
            const relative = path.relative(this.root, packageRoot);
            return micromatch_1.default.isMatch(relative, this.packageFilter);
        }
        // load or retrieve the cached packages and compare against that
        const packages = this.findPackagesSync();
        return packages.includes(packageRoot);
    }
    loadPackagesSync() {
        if (this.packageFilter) {
            return (0, common_1.findPackagesSync)(this.packageFilter, this.root);
        }
        return this.findWorkspacePackagesSync(this.sentinel);
    }
    loadPackages() {
        if (this.packageFilter) {
            return (0, common_1.findPackages)(this.packageFilter, this.root);
        }
        return this.findWorkspacePackages(this.sentinel);
    }
}
exports.WorkspacesInfoImpl = WorkspacesInfoImpl;
//# sourceMappingURL=info.js.map