"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.findWorkspacePackages = findWorkspacePackages;
exports.findWorkspacePackagesSync = findWorkspacePackagesSync;
exports.getPackageFilters = getPackageFilters;
const fs_1 = require("fs");
const path = __importStar(require("path"));
const common_1 = require("./common");
function filterSentinels() {
    return common_1.WORKSPACE_ROOT_SENTINELS.filter((sentinel) => sentinel !== common_1.LERNA_JSON);
}
// https://lerna.js.org/docs/configuration
async function findWorkspacePackages(configFile) {
    const { packages, useWorkspaces } = await (0, common_1.readJSON)(configFile);
    // `useWorkspaces` was deprecated: https://github.com/lerna/lerna/releases/tag/7.0.0
    // respect Lerna `packages` property
    if (packages && useWorkspaces !== true) {
        return await (0, common_1.findPackages)(packages, path.dirname(configFile));
    }
    // fall back to alternative sentinel regardless of `useWorkspaces`
    const root = path.dirname(configFile);
    const sentinels = filterSentinels();
    for (const sentinel of sentinels) {
        const filename = path.join(root, sentinel);
        if ((0, fs_1.existsSync)(filename)) {
            const { findWorkspacePackages } = await (0, common_1.getImplementation)(filename);
            return await findWorkspacePackages(filename);
        }
    }
    // return empty list if there is no alternative to fall back to
    return [];
}
function findWorkspacePackagesSync(configFile) {
    const packages = getPackageFilters(configFile);
    if (packages) {
        return (0, common_1.findPackagesSync)(packages, path.dirname(configFile));
    }
    return [];
}
function getPackageFilters(configFile) {
    const { packages, useWorkspaces } = (0, common_1.readJSONSync)(configFile);
    // `useWorkspaces` was deprecated: https://github.com/lerna/lerna/releases/tag/7.0.0
    // respect Lerna `packages` property
    if (packages && useWorkspaces !== true) {
        return packages;
    }
    const root = path.dirname(configFile);
    const sentinels = filterSentinels();
    for (const sentinel of sentinels) {
        const filename = path.join(root, sentinel);
        if ((0, fs_1.existsSync)(filename)) {
            const { getPackageFilters } = (0, common_1.getImplementationSync)(filename);
            return getPackageFilters(filename);
        }
    }
    return undefined;
}
//# sourceMappingURL=lerna.js.map