"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.findWorkspacePackages = findWorkspacePackages;
exports.findWorkspacePackagesSync = findWorkspacePackagesSync;
exports.getPackageFilters = getPackageFilters;
const path = __importStar(require("path"));
const common_1 = require("./common");
function parse({ workspaces }) {
    return Array.isArray(workspaces) ? workspaces : workspaces?.packages;
}
// https://docs.npmjs.com/cli/v8/using-npm/workspaces
// https://yarnpkg.com/configuration/manifest#workspaces
async function findWorkspacePackages(lockfile) {
    const root = path.dirname(lockfile);
    const manifest = await (0, common_1.readJSON)(path.join(root, "package.json"));
    return await (0, common_1.findPackages)(parse(manifest), root);
}
function findWorkspacePackagesSync(lockfile) {
    const root = path.dirname(lockfile);
    return (0, common_1.findPackagesSync)(getPackageFilters(lockfile), root);
}
function getPackageFilters(lockfile) {
    const root = path.dirname(lockfile);
    const manifest = (0, common_1.readJSONSync)(path.join(root, "package.json"));
    return parse(manifest);
}
//# sourceMappingURL=yarn.js.map